//serial test top module
module serialtest(REC,SEND,CLK,LED,_SYSCLK,BUTTON);
	input REC;
    input CLK;
	input BUTTON;
	output [7:0]LED;
	output SEND;
	output _SYSCLK;

	reg [1:0]prescale4=0;
	wire [7:0]bus1;
	wire orajel;			//divided clock
	wire rcvd;				//data has been received
	reg trmt;				//start transmit
	wire tr_iproc;			//transmit in process
	reg [7:0]data_rcvd;		//data buffer
	reg [15:0]postsc;		//post scaler

	prescaler p1(CLK,orajel);
	//assign orajel=CLK;
	
	receiver r1(REC,bus1,orajel,rcvd);
	transmitter t1(orajel,data_rcvd,trmt,SEND,tr_inproc);
	
	always@(posedge orajel)
		begin
		postsc<=postsc+1;
		if(rcvd==1)data_rcvd<=bus1+1;
		if(BUTTON&&!tr_inproc&&(postsc==16'h0000))trmt=1;
		else trmt=0;
		end 

	always@(posedge orajel)				//div4
		begin
		prescale4<=prescale4+1;
		end

	assign LED=data_rcvd;
	assign _SYSCLK=prescale4[1];

endmodule
