`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: Quenne Electric
// Engineer: Andras Bognar
// 
// Create Date:    20:35:17 05/18/2007 
// Design Name: 		RS232 transmitter
// Module Name:    transmitter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module transmitter(CLK, DATA, TRMT, OUT, INPROC);
	input CLK;
    input [7:0] DATA;
    input TRMT;			//start transmit
    output OUT;			//TxD
	output INPROC;		//transmit in process

	reg [11:0]shdata=0;	//shift reg.
	reg [1:0]div=0;	 	//clock divider (/3)
	reg trans=0;		//ads flag
	reg [3:0]bitsz=0;	//bitszmll
	wire parity;
	
	xor(parity,DATA[0],DATA[1],DATA[2],DATA[3],DATA[4],DATA[5],DATA[6],DATA[7]);

	always@(posedge CLK)
		begin
		if(TRMT==1)
			begin
			trans=1;
			div<=2'h0;
			shdata[9:2]<=DATA;
			shdata[1]<=0;
			shdata[10]<=parity;
			shdata[11]<=1;
			bitsz<=4'h0;
			end
		else
			begin
			div<=div+1;
			if(div==2'h2)div<=2'h0;
			if(trans==1)
				begin
				if(div==2'h2)
					begin
					shdata[10:0]<=shdata[11:1];
					bitsz<=bitsz+1;
					if(bitsz==4'hB)trans=0;
					end
				end
			else shdata[0]<=1;
			end
		end
		
		assign OUT=shdata[0];
		assign INPROC=trans;

endmodule
